// class_2.sce
// Classification in continuous data space 
// - with a teacher
// - off-line
// -------------------------------------
clc,clear,close,getd(),mode(0)

// simulation
nL=1000;                 // numb. of data for learning
nT=200;                  // numb. of data for testing
p=[.2 .5 .3];            // pointer model parameters
thS=[1 5 3               // component parameters
     1 2 8];             //   three clusters: [1 1],[5 2],[3 8]
for t=1:(nL+nT)
  y(t)=sum(cumsum(p)<rand(1,1,'u'))+1;            // data y (pointer)
  x(:,t)=thS(:,y(t))+1.2*eye(2,2)*rand(2,1,'n');  // data x
end
nc=size(thS,2);          // number of components

// estimation
xL=x(:,1:nL);            // data for
yT=y(1:nL);              //   learning
for j=1:max(y)
  s=find(yT==j);
  m{j}=mean(xL(:,s),2);  // component expecatations
  r{j}=cov(xL(:,s)');    // component variances
end

// classification
xT=x(:,nL+(1:nT));       // data for
yT=y(nL+(1:nT));         //   testing
for t=1:nT
  for j=1:nc
    q(j)=Gauss(xT(:,t),m{j},r{j}); // proximities
  end
  fy=q/sum(q);           // pointer prediction
  [nill,yp(t)]=max(fy);  // pointer value
  wt(:,t)=fy;
end

//result
Accuracy=sum(yT==yp)/nT
