// class_6a.sce
// Classification in continuous data space 
// - naive Bayes without teacher (= mixture estimation)
// -------------------------------------
clc,clear,close,getd(),mode(0)
getd c:\functions

// simulation
nI=20;              // number of initial data
nL=200;             // number of data for learninf
nT=200;             //number of data for testing
p=[.2 .5 .3];       // pointer parameters
thS=[               // model parameters
1 5 3               //   three clusters, five variables 
1 2 8
2 9 5
8 1 3
1 9 4];
[nv,nc]=size(thS);
for t=1:(nI+nL+nT)
  y(t)=sum(cumsum(p)<rand(1,1,'u'))+1;  // targer data
  for i=1:nv
    x(i,t)=thS(i,y(t))+.2*rand(1,1,'n');// explanatory data
  end
end

// initiation
xI=x(:,1:nI);       // data for 
yI=y(1:nI);         //   init.
ka=1*ones(nv,nc);   // counter
for j=1:nc
  s=find(yI==j);
  for i=1:nv
    m(i,j)=mean(xI(i,s));          // component expecatations
    r(i,j)=variance(xI(i,s));      // component variances
    S(i,j)=ka(i,j)*m(i,j);         // statistics
  end
end

// estimation
xL=x(:,nI+(1:nL));  // data for 
yL=y(nI+(1:nL));    //   learning
for t=1:nL
  for i=1:nv
    
    for j=1:nc
      [nill,Lq(j)]=GaussN(xL(i,t),m(i,j),.1); // proximity
    end                                       // in logarithm
    Lq=Lq-max(Lq);  // pre-normaliazation
    q=exp(Lq);      // log --> value
    w=q/sum(q);     // weight
    for j=1:nc
      S(i,j)=S(i,j)+w(j)*xL(i,t);  // statistic
      ka(i,j)=ka(i,j)+w(j);        //   update
      m(i,j)=S(i,j)/ka(i,j);       // estimate
    end
    
  end
end

// classification
xT=x(:,nI+nL+(1:nT));    // data for
yT=y(nI+nL+(1:nT));      //   classification
for t=1:nT
  for i=1:nv
    Lp=0;
    for j=1:nc
      [nill,Lq(j)]=GaussN(xT(i,t),m(i,j),.1); // proximity
    end
    Lq=Lq-max(Lq);
    Lp=Lp+Lq;            // sum in log = multiplication
  end
  q=exp(Lp);
  fy=q/sum(q);           // pointer prediction (= weights)
  [nill,yp(t)]=max(fy);  // pointe value
  wt(:,t)=fy;
end

// result
Accuracy=sum(yT==yp)/nT
