// model_7.sce
// Estimation of dynamic regression model
// -------------------------------------
clc,clear,close,mode(0)

//simulation
nd=200;                       // number of data
a1=.6; a2=-.3; b0=1; k=1;     // regression coefficients
r=.2;                         // variance
u=5*sin(2*%pi*(1:nd)/nd)+1;   // input
y(1)=2; y(2)=-1;              // initial conditions
for t=3:nd
  y(t)=a1*y(t-1)+a2*y(t-2)+b0*u(t)+k+sqrt(r)*rand(1,1,'n');
end                           // output

// estimation
V=zeros(5,5);                 // initial 
ka=0                          //   statistics
for t=3:nd
  Ps=[y(t) y(t-1) y(t-2) u(t) 1]'; // extended reg. vector
  V=V+Ps*Ps';                 //update of
  ka=ka+1;                    // statistics
end
Vy=V(1,1);
Vyp=V(2:$,1);
Vp=V(2:$,2:$);
thE=inv(Vp)*Vyp               // pont estimates of rerg. coef.
