// pred_1.sce
// Prediction with regression model
// -------------------------------------
clc,clear,close,mode(0)

// simulation
nd=200;                       // number of data
c=[5 3 -1];                   // regression coefficients
sd=1.2;                       // standard deviation
x=[2;-1;3]*ones(1,nd)+.5*(rand(3,nd,'n')); // data x
y=c*x+sd*rand(1,nd,'n');                   // data y

select 1  // SELECT type of prediction: 1-point, 2-simulated
case 1              // point prediction
for t=1:nd
  yp(t)=c*x(:,t);
end
case 2              // simulated prediction
for t=1:nd
  yp(t)=c*x(:,t)+sd*rand(1,1,'n');
end
end

// resulrs
set(scf(),'position',[500 200 500 400])
plot(1:nd,y,1:nd,yp)
legend('y','yp');
disp('Relative prediction error')
disp(variance(y-yp')/variance(y))
